import { Component, Input, ElementRef, Renderer } from '@angular/core';
import { ImageLoader } from "../../providers/image-loader";
import { ImageLoaderConfig } from "../../providers/image-loader-config";
export var ImgLoader = (function () {
    function ImgLoader(element, renderer, imageLoader, config) {
        this.element = element;
        this.renderer = renderer;
        this.imageLoader = imageLoader;
        this.config = config;
        this.useImg = false;
        this.width = '100%';
        this.height = '100%';
        this.isLoading = true;
        if (typeof this.spinner === 'undefined' && config.spinnerEnabled) {
            this.spinner = true;
        }
    }
    ImgLoader.prototype.ngOnInit = function () {
        var _this = this;
        this.imageLoader.getImagePath(this.imageUrl)
            .then(function (imageUrl) {
            var element;
            _this.isLoading = false;
            if (_this.useImg) {
                _this.renderer.createElement(_this.element.nativeElement, 'img');
                element = _this.element.nativeElement.getElementsByTagName('IMG')[0];
                _this.renderer.setElementAttribute(element, 'src', imageUrl);
            }
            else {
                element = _this.element.nativeElement;
                _this.renderer.setElementStyle(element, 'width', _this.width);
                _this.renderer.setElementStyle(element, 'height', _this.height);
                _this.renderer.setElementStyle(element, 'display', 'block');
                _this.renderer.setElementStyle(element, 'background-size', 'contain');
                _this.renderer.setElementStyle(element, 'background-repeat', 'no-repeat');
                _this.renderer.setElementStyle(element, 'background-image', 'url(\'' + imageUrl + '\')');
            }
        });
    };
    ImgLoader.decorators = [
        { type: Component, args: [{
                    selector: 'img-loader',
                    template: '<image-loader-spinner *ngIf="isLoading"></image-loader-spinner>'
                },] },
    ];
    /** @nocollapse */
    ImgLoader.ctorParameters = [
        { type: ElementRef, },
        { type: Renderer, },
        { type: ImageLoader, },
        { type: ImageLoaderConfig, },
    ];
    ImgLoader.propDecorators = {
        'imageUrl': [{ type: Input, args: ['src',] },],
        'spinner': [{ type: Input },],
        'useImg': [{ type: Input },],
        'width': [{ type: Input },],
        'height': [{ type: Input },],
    };
    return ImgLoader;
}());
//# sourceMappingURL=img-loader.js.map